unit IASciEdit;
//--------------------------------TIASciEdit v 1.0---------------------------
//--------This component is for entering of floating/integer values ---------
//////////////////////copyright by Andronov I.N 2001/////////////////////////
//
//
//

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,math;

type
  TIASciType = (iastFloat,iastInteger);
  TIASciReactionOnValueNotNumber = (iasrovnnSetDefault,iasrovnnUserMustCorrect);
  TIASciReactionOnValueOutOfMinMax = (iasrovoommSetDefault,iasrovoommSetNearestBound,iasrovoommUserMustcorrect);
  TIASciDecimalPointType = (iasdptDecimalSeparatorOnly,iasdptPointAndCommaAreEqual);
  TIASciEdit = class(TEdit)
  private
    FSciNFixedPrecitionDigits: Byte;
    FSciNIntegerAllDigits: Byte;
    FSciNFixedAllDigits: Byte;
    FSciNFloatAllDigits: Byte;
    FSciNFloatPrecitionDigits: Byte;
    FSciFloatMax: Extended;
    FSciFloatFixedMax: Extended;
    FSciFloatMin: Extended;
    FSciFloatDefault: Extended;
    FSciFloatValue: Extended;
    FSciFloatFixedMin: Extended;
    FSciIntMax: Integer;
    FSciIntegerValue: Integer;
    FSciIntDefault: Integer;
    FSciIntMin: Integer;
    FSciNotNumberString: string;
    FSciOutBoundsString: string;
    FSciErrorColor: TColor;
    FSciErrorFontColor: TColor;
    FSciFloatPointType: TIASciDecimalPointType;
    FSciReactNotNumber: TIASciReactionOnValueNotNumber;
    FSciReactOutBounds: TIASciReactionOnValueOutOfMinMax;
    FSciType: TIASciType;
    FOnNotNumber: TNotifyEvent;
    FOnNumberChange: TNotifyEvent;
    FOnOutOfBounds: TNotifyEvent;

    FTrueNumberColor : TColor;
    FTrueFontColor : TColor;
    FInternalColorChanging : Boolean;
    FSciNIntegerPrecitionDigits: Byte;
    FTextToDataFailed : Boolean;

    procedure SetSciErrorColor(  Value: TColor);
    procedure SetSciErrorFontColor(  Value: TColor);
    procedure SetSciFloatDefault(  Value: Extended);
    procedure SetSciFloatFixedMax(  Value: Extended);
    procedure SetSciFloatFixedMin(  Value: Extended);
    procedure SetSciFloatMax(  Value: Extended);
    procedure SetSciFloatMin(  Value: Extended);
    procedure SetSciFloatPointType(  Value: TIASciDecimalPointType);
    procedure SetSciFloatValue(  Value: Extended);
    procedure SetSciIntDefault(  Value: Integer);
    procedure SetSciIntegerValue(  Value: Integer);
    procedure SetSciIntMax(  Value: Integer);
    procedure SetSciIntMin(  Value: Integer);
    procedure SetSciNFixedAllDigits(  Value: Byte);
    procedure SetSciNFixedPrecitionDigits(  Value: Byte);
    procedure SetSciNFloatAllDigits(  Value: Byte);
    procedure SetSciNFloatPrecitionDigits(  Value: Byte);
    procedure SetSciNIntegerAllDigits(  Value: Byte);
    procedure SetSciNotNumberString(  Value: string);
    procedure SetSciOutBoundsString(  Value: string);
    procedure SetSciReactNotNumber(Value: TIASciReactionOnValueNotNumber);
    procedure SetSciReactOutBounds(Value: TIASciReactionOnValueOutOfMinMax);
    procedure SetSciType(Value: TIASciType);
    procedure SetOnNotNumber(Value: TNotifyEvent);
    procedure SetOnNumberChange(Value: TNotifyEvent);
    procedure SetOnOutOfBounds(Value: TNotifyEvent);

    procedure NumberChanged;
    procedure NumberIsNotNumber;
    procedure NumberOutOfBounds;
    function GetColor: TColor;
    function GetFont: TFont;
    procedure SetColor(Value: TColor);
    procedure SetFont(Value: TFont);
    procedure InheritedFontIsChanged(Sender: TObject);
    procedure SetColorsToError;
    procedure SetColorsToNormal;
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
    procedure WMKeyDown(var Message: TWMKeyDown); message WM_KEYDOWN;
    procedure TextToData;
    procedure DataToText;
    procedure SetSciNIntegerPrecitionDigits(Value: Byte);
    function GetSciFloatValue: Extended;
    function GetSciIntegerValue: Integer;
  protected
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;

    procedure Change; override;
    function LastConvertionIsOk : Boolean;
  published
    property SciType : TIASciType read FSciType write SetSciType default iastFloat;
    property SciIntegerValue : Integer read GetSciIntegerValue write SetSciIntegerValue default 0;
    property SciFloatValue : Extended read GetSciFloatValue write SetSciFloatValue;
    property SciIntDefault : Integer read FSciIntDefault write SetSciIntDefault default 0;
    property SciFloatDefault : Extended read FSciFloatDefault write SetSciFloatDefault;
    property SciIntMin : Integer read FSciIntMin write SetSciIntMin default -127;
    property SciIntMax : Integer read FSciIntMax write SetSciIntMax default 128;
    property SciFloatMin : Extended read FSciFloatMin write SetSciFloatMin;
    property SciFloatMax : Extended read FSciFloatMax write SetSciFloatMax;
    property SciReactNotNumber : TIASciReactionOnValueNotNumber read FSciReactNotNumber write SetSciReactNotNumber
                                 default iasrovnnSetDefault;
    property SciReactOutBounds : TIASciReactionOnValueOutOfMinMax read FSciReactOutBounds write SetSciReactOutBounds
                                 default iasrovoommSetDefault;
    property SciNotNumberString : string read FSciNotNumberString write SetSciNotNumberString;
    property SciOutBoundsString : string read FSciOutBoundsString write SetSciOutBoundsString;
    property SciErrorColor : TColor read FSciErrorColor write SetSciErrorColor default clBlack;
    property SciErrorFontColor : TColor read FSciErrorFontColor write SetSciErrorFontColor default clWhite;
    property SciFloatPointType : TIASciDecimalPointType read FSciFloatPointType write SetSciFloatPointType
                                 default iasdptPointAndCommaAreEqual;
    property SciFloatFixedMin : Extended read FSciFloatFixedMin write SetSciFloatFixedMin;
    property SciFloatFixedMax : Extended read FSciFloatFixedMax write SetSciFloatFixedMax;
    property SciNIntegerAllDigits : Byte read FSciNIntegerAllDigits write SetSciNIntegerAllDigits default 5;
    property SciNFloatAllDigits : Byte read FSciNFloatAllDigits write SetSciNFloatAllDigits default 12;
    property SciNFixedAllDigits : Byte read FSciNFixedAllDigits write SetSciNFixedAllDigits default 12;
    property SciNFloatPrecitionDigits : Byte read FSciNFloatPrecitionDigits write SetSciNFloatPrecitionDigits default 5;
    property SciNFixedPrecitionDigits : Byte read FSciNFixedPrecitionDigits write SetSciNFixedPrecitionDigits default 5;
    property SciNIntegerPrecitionDigits : Byte read FSciNIntegerPrecitionDigits write SetSciNIntegerPrecitionDigits default 0;

    //Events
    property OnNumberChange : TNotifyEvent read FOnNumberChange write SetOnNumberChange;
    property OnNotNumber    : TNotifyEvent read FOnNotNumber write SetOnNotNumber;
    property OnOutOfBounds  : TNotifyEvent read FOnOutOfBounds write SetOnOutOfBounds;

    //Rewrited Properties
    property Font : TFont read GetFont write SetFont;
    property Color : TColor read GetColor write SetColor;

  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('TIA', [TIASciEdit]);
end;

{ TIASciEdit }

procedure TIASciEdit.Assign(Source: TPersistent);
begin
  if assigned(source) and (source is TIASciEdit) then
    begin
      inherited Assign(Source);
      FSciNFixedPrecitionDigits:=(source as TIASciEdit).FSciNFixedPrecitionDigits;
      FSciNIntegerAllDigits:=(source as TIASciEdit).FSciNIntegerAllDigits;
      FSciNFixedAllDigits:=(source as TIASciEdit).FSciNFixedAllDigits;
      FSciNFloatAllDigits:=(source as TIASciEdit).FSciNFloatAllDigits;
      FSciNFloatPrecitionDigits:=(source as TIASciEdit).FSciNFloatPrecitionDigits;
      FSciFloatMax:=(source as TIASciEdit).FSciFloatMax;
      FSciFloatFixedMax:=(source as TIASciEdit).FSciFloatFixedMax;
      FSciFloatMin:=(source as TIASciEdit).FSciFloatMin;
      FSciFloatDefault:=(source as TIASciEdit).FSciFloatDefault;
      FSciFloatValue:=(source as TIASciEdit).FSciFloatValue;
      FSciFloatFixedMin:=(source as TIASciEdit).FSciFloatFixedMin;
      FSciIntMax:=(source as TIASciEdit).FSciIntMax;
      FSciIntegerValue:=(source as TIASciEdit).FSciIntegerValue;
      FSciIntDefault:=(source as TIASciEdit).FSciIntDefault;
      FSciIntMin:=(source as TIASciEdit).FSciIntMin;
      FSciNotNumberString:=(source as TIASciEdit).FSciNotNumberString;
      FSciOutBoundsString:=(source as TIASciEdit).FSciOutBoundsString;
      FSciErrorColor:=(source as TIASciEdit).FSciErrorColor;
      FSciErrorFontColor:=(source as TIASciEdit).FSciErrorFontColor;
      FSciFloatPointType:=(source as TIASciEdit).FSciFloatPointType;
      FSciReactNotNumber:=(source as TIASciEdit).FSciReactNotNumber;
      FSciReactOutBounds:=(source as TIASciEdit).FSciReactOutBounds;
      FSciType:=(source as TIASciEdit).FSciType;
      FTrueNumberColor:=(source as TIASciEdit).FTrueNumberColor;
      FTrueFontColor:=(source as TIASciEdit).FTrueFontColor;
      FSciNIntegerPrecitionDigits:=(source as TIASciEdit).FSciNIntegerPrecitionDigits;
    end else
    begin
      inherited Assign(Source);
    end;
end;

procedure TIASciEdit.Change;
begin
  inherited Change;
end;

procedure TIASciEdit.CMExit(var Message: TCMExit);
begin
  inherited;
  TextToData;
end;

constructor TIASciEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FSciNIntegerPrecitionDigits:=0;
  FSciNFixedPrecitionDigits:=5;
  FSciNIntegerAllDigits:=5;
  FSciNFixedAllDigits:=12;
  FSciNFloatAllDigits:=12;
  FSciNFloatPrecitionDigits:=5;
  FSciFloatMax:=1.0e8;
  FSciFloatFixedMax:=1.0e5;
  FSciFloatMin:=-1.0e8;
  FSciFloatDefault:=0.0;
  FSciFloatValue:=0.0;
  FSciFloatFixedMin:=-1.0e5;
  FSciIntMax:=128;
  FSciIntegerValue:=0;
  FSciIntDefault:=0;
  FSciIntMin:=-127;
  FSciNotNumberString:='The value is Not Number';
  FSciOutBoundsString:='Out Of Bounds';
  FSciErrorColor:=clBlack;
  FSciErrorFontColor:=clWhite;
  FSciFloatPointType:=iasdptPointAndCommaAreEqual;
  FSciReactNotNumber:=iasrovnnSetDefault;
  FSciReactOutBounds:=iasrovoommSetDefault;
  FSciType:=iastFloat;
  FOnNotNumber:=nil;
  FOnNumberChange:=nil;
  FOnOutOfBounds:=nil;
  inherited Font.OnChange:=InheritedFontIsChanged;
  FInternalColorChanging:=false;
  FTrueNumberColor:=inherited Color;
  FTrueFontColor:=(inherited Font).Color;
  DataToText;
end;

procedure TIASciEdit.DataToText;
var ds : string;
begin
  case FSciType of
    iastFloat :
      begin
        if (FSciFloatValue>=FSciFloatFixedMin) and (FSciFloatValue<=FSciFloatFixedMax) then
          begin
            ds:='%'+inttostr(FSciNFixedAllDigits)+'.'+inttostr(FSciNFixedPrecitionDigits)+'f';
            Text:=Format(ds,[FSciFloatValue]);
          end else
          begin
            ds:='%'+inttostr(FSciNFloatAllDigits)+'.'+inttostr(FSciNFloatPrecitionDigits)+'e';
            Text:=Format(ds,[FSciFloatValue]);
          end;
      end;//Float
    iastInteger :
      begin
        ds:='%'+inttostr(FSciNIntegerAllDigits)+'.'+inttostr(FSciNIntegerPrecitionDigits)+'d';
        Text:=Format(ds,[FSciIntegerValue]);
      end;
  end;
end;

destructor TIASciEdit.Destroy;
begin
  inherited Destroy;
end;

function TIASciEdit.GetColor: TColor;
begin
  result:=inherited Color;
end;

function TIASciEdit.GetFont: TFont;
begin
  result:=Inherited Font;
end;

function TIASciEdit.GetSciFloatValue: Extended;
begin
  TextToData;
  result:=FSciFloatValue;
end;

function TIASciEdit.GetSciIntegerValue: Integer;
begin
  TextToData;
  result:=FSciIntegerValue;
end;

procedure TIASciEdit.InheritedFontIsChanged(Sender: TObject);
begin
  if not FInternalColorChanging then
  FTrueFontColor:=(inherited Font).Color;
end;

function TIASciEdit.LastConvertionIsOk: Boolean;
begin
  result:=not FTextToDataFailed;
end;

procedure TIASciEdit.NumberChanged;
begin
  if assigned(FOnNumberChange) then FOnNumberChange(self);
end;

procedure TIASciEdit.NumberIsNotNumber;
begin
  if assigned(FOnNotNumber) then FOnNotNumber(self);
end;

procedure TIASciEdit.NumberOutOfBounds;
begin
  if assigned(FOnOutOfBounds) then FOnOutOfBounds(self);
end;

procedure TIASciEdit.SetColor(Value: TColor);
begin
  inherited Color:=Value;
  FTrueNumberColor:=inherited Color;
end;

procedure TIASciEdit.SetColorsToError;
begin
  FInternalColorChanging:=True;
  inherited Color:=SciErrorColor;
  Font.Color:=SciErrorFontColor;
  FInternalColorChanging:=False;
end;

procedure TIASciEdit.SetColorsToNormal;
begin
  FInternalColorChanging:=True;
  inherited Color:=FTrueNumberColor;
  Font.Color:=FTrueFontColor;
  FInternalColorChanging:=False;
end;

procedure TIASciEdit.SetFont(Value: TFont);
begin
  inherited Font:=Value;
  if not FInternalColorChanging then
  FTrueFontColor:=(inherited Font).Color;
end;

procedure TIASciEdit.SetOnNotNumber(Value: TNotifyEvent);
begin
  FOnNotNumber := Value;
end;

procedure TIASciEdit.SetOnNumberChange(Value: TNotifyEvent);
begin
  FOnNumberChange := Value;
end;

procedure TIASciEdit.SetOnOutOfBounds(Value: TNotifyEvent);
begin
  FOnOutOfBounds := Value;
end;

procedure TIASciEdit.SetSciErrorColor(  Value: TColor);
begin
  if Value<>FSciErrorColor then
    begin
      FSciErrorColor := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciErrorFontColor(  Value: TColor);
begin
  if Value<>FSciErrorFontColor then
    begin
      FSciErrorFontColor := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciFloatDefault(  Value: Extended);
begin
  if (Value<>FSciFloatDefault) and (Value>=FSciFloatMin) and (Value<=FSciFloatMax) then
    begin
      FSciFloatDefault := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciFloatFixedMax(  Value: Extended);
begin
  if (Value<>FSciFloatFixedMax) then
    begin
      FSciFloatFixedMax := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciFloatFixedMin(  Value: Extended);
begin
  if (Value<>FSciFloatFixedMin) then
    begin
      FSciFloatFixedMin := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciFloatMax(  Value: Extended);
begin
  if (Value<>FSciFloatMax) then
    begin
      FSciFloatMax := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciFloatMin(  Value: Extended);
begin
  if (Value<>FSciFloatMin) then
    begin
      FSciFloatMin := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciFloatPointType(Value: TIASciDecimalPointType);
begin
  if (Value<>FSciFloatPointType) then
    begin
      FSciFloatPointType := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciFloatValue(  Value: Extended);
begin
  if (Value>=FSciFloatMin) and (Value<=FSciFloatMax) and (Value<>FSciFloatValue) then
    begin
      FSciFloatValue := Value;
      DataToText;
      NumberChanged;
    end;
end;

procedure TIASciEdit.SetSciIntDefault(  Value: Integer);
begin
  if (Value<>FSciIntDefault) and (Value>=FSciIntMin) and (Value<=FSciIntMax) then
    begin
      FSciIntDefault := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciIntegerValue(  Value: Integer);
begin
  if (Value>=FSciIntMin) and (Value<=FSciIntMax) and (Value<>FSciIntegerValue) then
    begin
      FSciIntegerValue := Value;
      DataToText;
      NumberChanged;
    end;
end;

procedure TIASciEdit.SetSciIntMax(  Value: Integer);
begin
  if (Value<>FSciIntMax) then
    begin
      FSciIntMax := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciIntMin(  Value: Integer);
begin
  if (Value<>FSciIntMin) then
    begin
      FSciIntMin := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciNFixedAllDigits(  Value: Byte);
begin
  if (Value<>FSciNFixedAllDigits) and (Value>0) then
    begin
      FSciNFixedAllDigits := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciNFixedPrecitionDigits(  Value: Byte);
begin
  if (Value<>FSciNFixedPrecitionDigits) then
    begin
      FSciNFixedPrecitionDigits := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciNFloatAllDigits(  Value: Byte);
begin
  if (Value<>FSciNFloatAllDigits) and (Value>0) then
    begin
      FSciNFloatAllDigits := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciNFloatPrecitionDigits(  Value: Byte);
begin
  if (Value<>FSciNFloatPrecitionDigits) then
    begin
      FSciNFloatPrecitionDigits := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciNIntegerAllDigits(  Value: Byte);
begin
  if (Value<>FSciNIntegerAllDigits) and (Value>0) then
    begin
      FSciNIntegerAllDigits := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciNIntegerPrecitionDigits(Value: Byte);
begin
  if (Value<>FSciNIntegerPrecitionDigits) then
    begin
      FSciNIntegerPrecitionDigits := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciNotNumberString(  Value: string);
begin
  if (Value<>FSciNotNumberString) then
    begin
      FSciNotNumberString := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciOutBoundsString(  Value: string);
begin
  if (Value<>FSciOutBoundsString) then
    begin
      FSciOutBoundsString := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciReactNotNumber(Value: TIASciReactionOnValueNotNumber);
begin
  if (Value<>FSciReactNotNumber) then
    begin
      FSciReactNotNumber := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciReactOutBounds(Value: TIASciReactionOnValueOutOfMinMax);
begin
  if (Value<>FSciReactOutBounds) then
    begin
      FSciReactOutBounds := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.SetSciType(  Value: TIASciType);
begin
  if (Value<>FSciType) then
    begin
      FSciType := Value;
      DataToText;
    end;
end;

procedure TIASciEdit.TextToData;
var s : string;
    n,n1 : integer;
    D : extended;
begin
  s:=text;
  while pos(' ',s)=1 do delete(s,1,1);
  FTextToDataFailed:=True;
  case FSciType of
    iastFloat :
      begin
        case FSciFloatPointType of
          iasdptPointAndCommaAreEqual :
            begin
              n:=pos('.',s);
              n1:=pos(',',s);
              if n1>0 then
                begin
                  if n>0 then
                    begin
                      n:=min(n,n1);
                    end else
                    begin
                      n:=n1;
                    end;
                end else
                begin
                  if n>0 then
                    begin
                      //n=n
                    end else
                    begin
                      n:=0;
                    end;
                end;
              if N>0 then
                begin
                  delete(s,n,1);
                  insert(DecimalSeparator,s,n);
                end;
            end;
          end;
          n:=pos(DecimalSeparator,s);
          if (N>0) or (pos('e',s)>0) or (pos('E',s)>0)then
            begin //This is Extended type ?
              if TextToFloat(PChar(S), D, fvExtended) then
              begin
                D:=strtofloat(s);
                if (D<SciFloatMin) or (D>SciFloatMax) then
                  begin
                    if FSciOutBoundsString<>'' then showmessage(FSciOutBoundsString);
                    case FSciReactOutBounds of
                      iasrovoommSetDefault :
                        begin
                          FSciFloatValue:=FSciFloatDefault;
                          SetColorsToNormal;
                          FTextToDataFailed:=false;
                          DataToText;
                        end;
                      iasrovoommSetNearestBound :
                        begin
                          SetColorsToNormal;
                          if (D<SciFloatMin) then
                            begin
                              FSciFloatValue:=SciFloatMin;
                            end else
                            begin
                              FSciFloatValue:=SciFloatMax;
                            end;
                          FTextToDataFailed:=false;
                          DataToText;
                        end;
                      iasrovoommUserMustcorrect :
                        begin
                          SetColorsToError;
                        end;
                    end;
                    NumberOutOfBounds;
                  end else
                  begin
                    SciFloatValue:=D;
                    SetColorsToNormal;
                    FTextToDataFailed:=false;
                  end;
              end else
              begin
                if FSciNotNumberString<>'' then
                  begin
                    ShowMessage(FSciNotNumberString);
                  end;
                case FSciReactNotNumber of
                  iasrovnnSetDefault :
                    begin
                      SciFloatValue:=FSciFloatDefault;
                      FTextToDataFailed:=false;
                      DataToText;
                    end;
                  iasrovnnUserMustCorrect :
                    begin
                      SetColorsToError;
                    end;
                end;
                NumberIsNotNumber;
              end; //Convertion to float
            end else
            begin //This is integer type as extended?
              {$R-}
              Val(S,N,N1);
              {$R+}
              if N1=0 then
              begin
                if (N<SciFloatMin) or (N>SciFloatMax) then
                  begin
                    if FSciOutBoundsString<>'' then showmessage(FSciOutBoundsString);
                    case FSciReactOutBounds of
                      iasrovoommSetDefault :
                        begin
                          FSciFloatValue:=FSciFloatDefault;
                          SetColorsToNormal;
                          FTextToDataFailed:=false;
                          DataToText;
                        end;
                      iasrovoommSetNearestBound :
                        begin
                          SetColorsToNormal;
                          if (N<SciFloatMin) then
                            begin
                              FSciFloatValue:=SciFloatMin;
                            end else
                            begin
                              FSciFloatValue:=SciFloatMax;
                            end;
                          FTextToDataFailed:=false;
                          DataToText;
                        end;
                      iasrovoommUserMustcorrect :
                        begin
                          SetColorsToError;
                        end;
                    end;
                    NumberOutOfBounds;
                  end else
                  begin
                    SciFloatValue:=n;
                    FTextToDataFailed:=false;
                    SetColorsToNormal;
                  end;
              end else
              begin
                if FSciNotNumberString<>'' then
                  begin
                    ShowMessage(FSciNotNumberString);
                  end;
                case FSciReactNotNumber of
                  iasrovnnSetDefault :
                    begin
                      SciFloatValue:=FSciFloatDefault;
                      FTextToDataFailed:=false;
                      DataToText;
                    end;
                  iasrovnnUserMustCorrect :
                    begin
                      SetColorsToError;
                    end;
                end;
                NumberIsNotNumber;
              end;     //To Integer...

        end;//point type
      end;//Float
    iastInteger :
      begin
        {$R-}
        Val(S,N,N1);
        {$R+}
        if N1=0 then
        begin
          if (N<SciIntMin) or (N>SciIntMax) then
            begin
              if FSciOutBoundsString<>'' then showmessage(FSciOutBoundsString);
              case FSciReactOutBounds of
                iasrovoommSetDefault :
                  begin
                    FSciIntegerValue:=FSciIntDefault;
                    SetColorsToNormal;
                    FTextToDataFailed:=false;
                    DataToText;
                  end;
                iasrovoommSetNearestBound :
                  begin
                    SetColorsToNormal;
                    if (N<SciIntMin) then
                      begin
                        FSciIntegerValue:=SciIntMin;
                      end else
                      begin
                        FSciIntegerValue:=SciIntMax;
                      end;
                    FTextToDataFailed:=false;
                    DataToText;
                  end;
                iasrovoommUserMustcorrect :
                  begin
                    SetColorsToError;
                  end;
              end;
              NumberOutOfBounds;
            end else
            begin
              SciIntegerValue:=n;
              FTextToDataFailed:=false;
              SetColorsToNormal;
            end;
        end else
        begin
          if FSciNotNumberString<>'' then
            begin
              ShowMessage(FSciNotNumberString);
            end;
          case FSciReactNotNumber of
            iasrovnnSetDefault :
              begin
                SciIntegerValue:=FSciIntDefault;
                FTextToDataFailed:=false;
                DataToText;
              end;
            iasrovnnUserMustCorrect :
              begin
                SetColorsToError;
              end;
          end;
          NumberIsNotNumber;
        end;
      end;//to integer
  end;
end;

procedure TIASciEdit.WMKeyDown(var Message: TWMKeyDown);
begin
  inherited;
  if Message.CharCode=VK_RETURN then TextToData;
end;

end.
